# /usr/bin/perl 

=pod

Read the nxcgtx.rdb and produce a file suitable for importing
into the flashcard program Anki.

=cut

use strict;
use gzb_ascii_unicode;


my $word;
my $gloss;
my $RootType;
my $outfile = "anki-lexicon-import.tab";
my $etym;

open ANKI,  ">:encoding(UTF-8)", $outfile
    or die "can't open $outfile for writing";

while ( <> ) {
    s/[\r\n]+$//;

    my @fields = split( "\t", $_ );
    $word  	= $fields[0];
    $RootType 	= $fields[1];
    $gloss 	= $fields[2];
    $etym 	= $fields[5];
    if ( $RootType eq 'p'  and  $etym eq "AUTOGENERATED" ) {
	next;
    }

    if ($RootType =~ /[bfmpksndr]/) { 
	my $out = "$word\t$gloss\n";
	$out =~ s/&/&amp;/g;
	$out =~ s/>/&gt;/g;
	$out =~ s/</&lt;/g;
	$out =~ s/"/&quot;/g;
	print ANKI gzb_ascii_unicode_convert( $out );
    }
}
