
use strict;


my $wordcount;
my $totallen;
my @fields;
my $arg;
my $nxcgtx = undef;
my $roottypes = undef;

my $pct = 0;

my $unknownfile = "unknown.rdb";
my $knownfile = "known.rdb";

while ( $arg = shift ) {
    if ( $arg !~ /^-/ ) {
	$nxcgtx = shift;
	next;
    }
    if ( $arg = "-r" ) {
	$roottypes = shift;
    }
}

if ( not defined $nxcgtx ) {
    $nxcgtx = "nxcgtx.rdb";
}


if ( not defined $roottypes ) {
    $roottypes = "rsmk";
}

open NXCGTX,  $nxcgtx   or die "can't open $nxcgtx for reading";

my $sylls;
my $totalsylls;
while ( <NXCGTX> ) {
    @fields = split(  /\t/, $_ );
    if ( $fields[1] =~ m/[$roottypes]/ ) {
	$wordcount++;
	my $word = $fields[0];
	my $wmangle = $word;
        $sylls = ($wmangle =~ s/[aeiouy]/_/g);
	if ( $word =~ m/rq/ ) {
	    $sylls++;
	}
        $totalsylls += $sylls;
	$word =~ s/[-'xq]//g;
	my $len = length( $word );
        $totallen += $len;

        printf "%-2d\t%-2d\t%s\n", $len, $sylls, $fields[0];
    }    
}

my $avg = $totallen / $wordcount;
my $avgsyll = $totalsylls / $wordcount;
print "\ntotal words: $wordcount\n";
print "average phonemes per word: $avg\n";
print "average syllables per word: $avgsyll\n\n";

