#! /bin/bash

cat nxcgtx.rdb \
| awk 'BEGIN {
	FS=OFS="\t"
}

$2 ~ /[dmpksnr]/ {
	if ( $5 == "" ) {
	     print "undated";
	} else {
	     print $5;
	}
}' > dates.tmp

echo " "
#echo "roots only (no derivatives or foreign names)"
echo " "
echo " by year"
cat dates.tmp | cut -c 1-4 | sort | uniq -c
echo " "
echo " by month"
cat dates.tmp | cut -c 1-7 | sort | uniq -c
echo " "
echo " by day"
sort dates.tmp | uniq -c 

cat nxcgtx.rdb \
| awk 'BEGIN {
	FS=OFS="\t"
}

NR>2 && $2 !~ /[zx]/ {
	if ( $5 == "" ) {
	     print "undated";
	} else {
	     print $5;
	}
}' > dates2.tmp


echo " "
echo "all words"
echo " "
echo " by year"
cat dates2.tmp | cut -c 1-4 | sort | uniq -c
echo " "
echo " by month"
cat dates2.tmp | cut -c 1-7 | sort | uniq -c
echo " "
echo " by day"
sort dates2.tmp | uniq -c 


echo " "
echo roots with etymologies:


cat nxcgtx.rdb \
| awk 'BEGIN {
	FS=OFS="\t"
}

NR>2 && $2 ~ /[mpksnr]/ && $6 != "" {
	if ( $5 == "" ) {
	     print "undated";
	} else {
	     print $5;
	}
}' > dates3.tmp

echo " "
echo " by year"
cat dates3.tmp | cut -c 1-4 | sort | uniq -c
echo " "
echo " by month"
cat dates3.tmp | cut -c 1-7 | sort | uniq -c

rm dates*.tmp  # comment this line out for debugging
