#! /usr/bin/perl -w

use warnings;
use strict;

my $roottypes = "rdspnkm";
my $nxcgtx = "nxcgtx.rdb";
my $archaic = "gzb_archaic_list.txt";

open NXCGTX,  $nxcgtx   or die "can't open $nxcgtx for reading";
open ARCHAIC, "> $archaic"    or die "can't open $archaic for writing";


while ( <NXCGTX> ) {
    my $line = $_;
    # first two lines are header, skip them
    if ( $. < 3 ) {
	next;
    }
    chomp;
    s/__//g;
    my @fields = split(  /\t/, $_ );

    if ( $fields[ 1 ] !~ /[$roottypes]/ ) {
	next;
    }

    next if not defined $fields[2];
    next if defined $fields[5] && $fields[5] =~ m/AUTOGENERATED/;
    next if $fields[2] =~ m/nonce/;
    if ( $fields[2] =~ m/archaic(?!ally)/ ) { 
        print ARCHAIC $line;
    }
}

close;
