
# input needs to have been converted to unicode html entities
# by gzb-ascii-unicode.awk

use strict;

my $file = shift; 

if ( not defined $file ) { 
    $file = "modifiers-unicode.txt"; 
}

my $targetfile = shift;
if ( not defined $targetfile ) { 
    $targetfile = "grammar.htm"; 
}

open SF, $file       or die "can't open search string source $file";
open TF, $targetfile or die "can't open search target $targetfile";

my @searchstrings;
my @filelines;
while ( <SF> ) {
    chomp;
    push @searchstrings, $_;
}

while ( <TF> ) {
    chomp;
    push @filelines, $_;
}



print "<table>\n";

foreach ( @searchstrings ) {
    my $search = $_;
    my $origsearch = $_;
    $search =~ s/\&/\\&/g;
    $search =~ s/\#/\\#/g;
    $search =~ s/\;/\\;/g;
    if ( $search !~ /^\\&/ ) {
	$search = "\\b$search";
    }
    if ( $search !~ /;$/ ) {
	$search = "$search\\b";
    }
    my @results = grep ( /$search/, @filelines );
    print "<tr><td> " . scalar(@results) . "\t<td> " . $origsearch . "\t<td> "
	. $search  . " </tr> \n";
}

print "</table>\n";
