#/bin/perl 
 
eval '$'.$1.'$2;' while $ARGV[0] =~ /^([A-Za-z_0-9]+=)(.*)/ && shift; 
			# process any FOO=bar switches 
 

$, = ' ';		# set output field separator 
$\ = "\n";		# set output record separator 

# TODO: read in whole file, split each line, stash array reg in array
# or hash then sort keys and process each wanted line postprocess each
# line by stripping out '__' (so obviate need for wrapper shell script
# that sorts input and strips __ from output, also make it possible to
# detect words in glosses and morphemes in compound words that need to
# be linked

use strict;
use gzb_ascii_unicode;

sub make_hyperlink( $ );
sub linkify( $ );

my $entry_count = 0;
my $nxiqn_daxm_zqa = 0;
my $bjax_niqm = 0;
my $cqur = 0;
my $derived = 0;
my $dxujm = 0;
my $gun = 0;
my $jum = 0;
my $nxwiqm = 0;
my $pxyr = 0;
my $roots = 0;

my $Word;
my $RootType;
my $gloss;
my $Fld4;
my $Fld5;
my $etym;

my $anchor;


print<<HEADER;
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN"
       "http://www.w3.org/TR/REC-html40/strict.dtd">
<html>
<head>
<title>
gj&#226;-zym-byn (gzb): Lexicon / Glosaro / nxiqn-cu gjax-txy-za
</title>
<meta name = "keywords" "content = "lexicon glosaro word list root derived constructed language conlang">
<meta name = "generator" content="gen-nxcgtx_htm.pl">
<style> BODY { font-family: "Lucida Sans Unicode", sans-serif } </style>
</head>
<body>
<h1>
<a target="_top" href="gzb.htm">gj&#226;-zym-byn</a> (gzb)<br>Lexicon / Glosaro / nxiqn-cu gjax-txy-za
</h1>

<DL>
HEADER


my @rows;
my @lexicon_entries;

 
while (<>) { 
    #chomp;	# strip record separator 
    s/[\r\n]+$//;

#    ( $Word, $RootType, $gloss, $Fld4, $Fld5, $etym ) = split("\t", $_, 9999); 
    my @fields = split( "\t", $_ );
    $RootType = $fields[1];
    $etym = $fields[5];

    # include all entry types except (x) erroneous forms, and (z) reserved for future use  
    if ($RootType =~ /[bfmpksndr]/) { 
	push @rows, \@fields;
	push @lexicon_entries, $fields[0];
	$entry_count++; 
 
	if ($RootType =~ /[mpksnr]/) { 
	    $roots++; 
	} 
	if ($RootType eq 'r') { 
	    $gun++; 
	} 
	if ($RootType eq 'n') { 
	    $nxwiqm++; 
	} 
	if ($RootType eq 'm') { 
	    $jum++; 
	} 
	if ($RootType eq 'p') { 
	    $cqur++; 
	} 
	if ($RootType eq 'k') { 
	    $dxujm++; 
	} 
	if ($RootType eq 's') { 
	    $pxyr++; 
	} 
 
	if ($RootType =~ /[bf]/) { 
	    $bjax_niqm++; 
	} 
	if ($RootType eq 'd') { 
	    $derived++; 
	} 
	if (defined( $etym ) && $etym ne "" & $etym ne "AUTOGENERATED" ) { 
	    $nxiqn_daxm_zqa++; 
	} 
    }
}


my $line = 0;
# sort array and print output for each line of it
foreach ( sort { my @p = @{$a}; my @q = @{$b}; return lc( $p[0] ) cmp lc( $q[0] ) } @rows ) {
	( $Word, $RootType, $gloss, $Fld4, $Fld5, $etym ) = @{ $_ };
	my $output_item = "";
	$anchor = $Word; 
	my $s = "'";
	$anchor =~ s/$s//g; 
 	$anchor =~ s/ /___/g; 

	# TODO: factor out similar code in linkify() and call that function here
	# instead of duplicating it (can't simply call linkify() here or it will
	# link each compound word to itself)
        if ( $Word =~ /[- ]/ ) {
	    # split on morphemes, link each morpheme to another entry
	    my @morphemes = split( /([- ])/, $Word );
	    my $linkedword = "";
	    my $j = 0;
	    for ( $j = 0; $j < scalar(@morphemes); $j++ ) {
		if ( grep { $_ eq @morphemes[$j] } @lexicon_entries ) {
		    $linkedword .= make_hyperlink( $morphemes[$j] );
		} else {
		    $linkedword .= $morphemes[$j];
		}
	    }
	    $Word = $linkedword;
        }

	$output_item .= "<DT id=\"" . $anchor . "\">" . gzb_ascii_unicode_convert( $Word ) . "\n"; 

	if ( $gloss =~ m/\{.+\}/ ) {
	    $gloss =~ s/(\{[^}]+\})/linkify($1)/ge;
	}
	$output_item .= '<DD>' . gzb_ascii_unicode_convert( $gloss ) . "\n";  
 
	if ( defined( $etym ) && $etym ne "" ) { 
	    $etym =~ s/i\^/\\$&#xEE;/g; 
	    $etym =~ s/a:/\\$&#xE4;/g; 
	    $etym =~ s/o:/\\$&#xF6;/g; 
	    $output_item .= '( &lt; ' . $etym . ")\n"; 
	} 
	
	# double-underscore was used to mask digraphs in anchor text etc. that should not be affected by 
	# gzb_ascii_unicode_convert()
	$output_item =~ s/__//g;
	print $output_item;

} # end for each line in lexicon 
 
print "</DL>\n"; 
 
print '<hr>'; 
 
print '<table cellspacing=5>'; 
print '<tr><td> &nbsp;  Total content roots: <td> ' . $gun; 
print '<tr><td> &nbsp;  Total pronouns: <td> ' . $nxwiqm; 
print '<tr><td> &nbsp;  Total modifier particles: <td> ' . $jum; 
print '<tr><td> &nbsp;  Total conjunctions: <td> ' . $dxujm; 
print '<tr><td> &nbsp;  Total suffixes: <td> ' . $pxyr; 
print '<tr><td> &nbsp;  Spacetime postpositions: <td> ' . $cqur;
print '<tr><td> Total root morphemes: <td> ' . $roots; 
print '<tr><td> Total derived words: <td> ' . $derived; 
print '<tr><td> Total acronyms and foreign names: <td> ' . $bjax_niqm; 
print '<tr><td> Total <em>a posteriori</em> roots (words with etymologies) <td> ' . $nxiqn_daxm_zqa; 
print '<tr><td> Total entries: <td> ' . $entry_count; 
print '</table>'; 
 
print '<ul>'; 
print "<li><a target=\"_top\"  href=\"nxcgx.rdb\">Tab-delimited text version of lexicon (from which this file is automatically generated)</a>  "; 
print  "<li><a target=\"_top\"   href=\"gzb.htm\">Main {gj&#226;-zym-byn} index </a>  "; 
print "<li><a target=\"_top\"   href=\"phonology.htm\">Phonology </a> "; 
print "<li><a target=\"_top\"   href=\"grammar.htm\">Grammar</a> "; 
print "<li><a target=\"_top\"   href=\"semantic.htm\">Semantics</a> "; 
print "<li><a target=\"_top\"   href=\"../conlang.htm\"> My conlang page</a> "; 
print "<li><a target=\"_top\"   href=\"../index.htm\"> My home page</a>"; 
print "</ul>\n"; 
 
print '<p>Last modified / lasta &#285;isdatigo <br>'; 
print scalar( localtime() ); 
print "\n</body></html>\n"; 

### END



sub make_hyperlink( $ ) {
    my $linkword = shift;
    my $anchortext = $linkword;
    $anchortext =~ s/'//g;
    $anchortext =~ s/x/__x/g;
    $anchortext =~ s/q/__q/g;
    my $link = qq(<a href="#$anchortext">$linkword</a>);
    return $link;
}

sub linkify ( $ ) {
    my $arg = shift;
    my $linkified_text = "";
    # split line, saving delimiters and words in alternate result fields
    my @words = split(/([\s!?.{}\[\],;:~]+)/, $arg );
    for ( my $i = 0; $i < scalar(@words); $i++) {
	##print "line $line word $i: " . $words[$i] . "\n";   ##DEBUG
	
	
	if ( grep {  $words[$i]  eq $_ } @lexicon_entries ) {
	     $words[$i]  = &make_hyperlink(  $words[$i]  );
	} elsif (  $words[$i]  =~ /-/ ) {
	    ##print "found compound not in lexicon:  $words[$i]  \n";
	    # if no match found and word contains '-'
	    my @morphemes = split( /-/,  $words[$i]  );
	    my $linkedword = "";
	    my $j = 0;
	    for ( $j = 0; $j < scalar(@morphemes); $j++ ) {
		##print "line $line word $i morpheme $j: " . $morphemes[$j] . "\n";   ##DEBUG
		# check for match in nxcgtx array
		if ( grep { $morphemes[$j] eq $_ } @lexicon_entries ) {
		    $linkedword .= &make_hyperlink( $morphemes[$j] );
		} else {
		    $linkedword .= $morphemes[$j];
		}
		    if ( $j < (scalar(@morphemes) - 1) ) {
			$linkedword .= "-";
		    }
	    } ## end for each morpheme in compound
	    $words[$i]  = $linkedword;
	}
	$linkified_text .=  $words[$i];
    } ## end for each word on nonblank line

    return $linkified_text;
}
