#! /usr/bin/perl -w

use strict;
use warnings;

# first slurp in nxcgtx

open NXCGTX, "nxcgtx.rdb" or die "can't open nxcgtx.rdb";

my %in_lex;
my %out_lex;

my $n1 = 0; # loop counter

while ( <NXCGTX> ) {
    my @fields = split /\t/;
    $in_lex{ $fields[0] } = \@fields;
}

my $type;

while ( <> ) {
    my $line = $_;
    next if m/^\s*$/;
    my @words_this_line = split m/[ !:.?*{},;\r\n]+/;

    my $n2 = 0; # loop counter
    foreach ( @words_this_line ) {
	if ( $n2++ > 100000 ) {
	    print "current line: $line current word: $_\n";
	    die "endless loop in foreach words_this_line";
	}

	 if ( not defined $in_lex{ $_ } ) {
	     print "$_ is not in lexicon\n";
	     if ( m/-/ ) {
		 my @morphemes = split m/-/;
		 push @words_this_line, @morphemes;
	     }
	     next;
	 }
	 my @lex_entry = @{ $in_lex{ $_ } };
	 if ( $lex_entry[1] eq "r" ) {
	     $type = "n.";
	 } elsif (  $lex_entry[1] eq "m" ) {
	     $type = "mod.";
	 } elsif (  $lex_entry[1] eq "k" ) {
	     $type = "conj.";
  	 } elsif (  $lex_entry[1] eq "s" ) {
	     $type = "suff.";
	 } elsif (  $lex_entry[1] eq "n" ) {
	     $type = "pron.";
	 } elsif (  $lex_entry[1] eq "p" ) {
	     $type = "postp.";
	 } elsif (  $lex_entry[1] eq "d" ) {
	     $type = "zzz";
	     if ( ! m/-/ ) {
		 print STDERR "Lexeme $_ is mis-tagged as derived but contains no hyphens\n";
		 die;
	     }
	     my @morphemes = split m/-/;
	     push @words_this_line, @morphemes;
	     
	 } else { 
	     print STDERR "warning: $_ is used in text but its root type is not accounted for in script\n";
	     $type = "*****";
	 }
	$lex_entry[2] =~ s/\s*\(xref[^\)]+\)//;
	 $out_lex{ $_ } = $_ . "\t" . $type . "\t" . $lex_entry[2] . "\n";
     }

    if ( $n1++ > 100000 ) {
	die "endless loop in while stdin";
    }

}

foreach ( sort keys %out_lex ) {
    print $out_lex{ $_ };
}

