#! /usr/bin/perl -w

use warnings;
use strict;

my $roottypes = "rdspnkm";
my $nxcgtx = "nxcgtx.rdb";
my $anki = "gzb_anki.txt";

open NXCGTX,  $nxcgtx   or die "can't open $nxcgtx for reading";
open ANKI, "> $anki"    or die "can't open $anki for writing";

while ( <NXCGTX> ) {
    # first two lines are header, skip them
    if ( $. < 3 ) {
	next;
    }
    chomp;
    s/__//g;
    my @fields = split(  /\t/, $_ );

    if ( $fields[ 1 ] !~ /[$roottypes]/ ) {
	next;
    }

    next if not defined $fields[2];
    next if defined $fields[5] && $fields[5] =~ m/AUTOGENERATED/;
    next if $fields[2] =~ m/nonce/;
    next if $fields[2] =~ m/archaic(?!ally)/;
    $fields[3] =~ s/ /_/g;

    print ANKI $fields[0] . "\t" . $fields[2] . "\t" . $fields[3] . "\n";
}

close;
